@use kitchen_sink::CompatByCrateVersion;
@use kitchen_sink::Compat;
@use kitchen_sink::ClippyResult;

@(table: (Vec<u16>, CompatByCrateVersion), clippys: &[(f32, ClippyResult)])

<h1>Crate compatibility matrix</h1>
<style>
    #compat-debug td @{ cursor: default; @}
    #compat-debug td[title] @{ cursor: help; @}
    #compat-debug td.bad @{  background: #fee; @}
    #compat-debug td.bad.certain @{  background: #faa; @}
    #compat-debug td.ok @{  background: #efe; @}
    #compat-debug td.ok.certain @{  background: #afa; @}
    #compat-debug td.ok.bad @{  background: #aaa; @}
</style>
<table id="compat-debug">
    <thead><tr><th></th>
        @for rustc_ver in table.0.iter().rev() {
            <th>1.@rustc_ver</th>
        }
    </tr></thead>
    <tbody>
        @for (v, row) in table.1.iter().rev() {
            <tr>
                <th>@v</th>
                @for rustc_ver in table.0.iter().rev().copied() {
                    <td
                        @if let Some((_, Some(reason))) = row.compat_data_for_rustc(rustc_ver) {title="@reason"}
                        class='
                        @if rustc_ver <= row.newest_bad().unwrap_or(0) {bad}
                        @if rustc_ver <= row.newest_bad_certain().unwrap_or(0) {bad certain}
                        @if rustc_ver >= row.oldest_ok().unwrap_or(999) {ok}
                        @if rustc_ver >= row.oldest_ok_certain().unwrap_or(999) {ok certain}
                    '>
                        @if let Some((compat, reason)) = row.compat_data_for_rustc(rustc_ver) {
                            @if reason.unwrap_or("").starts_with("assumed from ") {.} else {
                                @if compat == Compat::VerifiedWorks {
                                    ✅
                                }
                                @if compat == Compat::ProbablyWorks {
                                    ✓
                                }
                                @if compat == Compat::MaybeWorks {
                                    -
                                }
                                @if compat == Compat::DefinitelyIncompatible || compat == Compat::LikelyIncompatible {
                                    ❌
                                }
                                @if compat == Compat::SuspectedIncompatible {
                                    𐄂
                                }
                                @if compat == Compat::BrokenDeps {
                                    d
                                }
                                @if compat == Compat::BrokenDepsLikely {
                                    D
                                }
                            }
                       }
                    </td>
                }
            </tr>
        }
    </tbody>
</table>

@if !clippys.is_empty() {
    <table>
        <caption>
              @clippys.len() issue(s), @(clippys.iter().map(|c| c.0).sum::<f32>().round()) sum
        </caption>
        @for (score, c) in clippys {
            <tr><td>@((score*10.).round()/10.)</td><td>@c.code</td><td>@c.msg</td><td>x @c.count</td></tr>
        }
    </table>
}
